-- Creaci de seqncies
CREATE SEQUENCE seq_idAssignatura	
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE SEQUENCE seq_idCurs
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE SEQUENCE seq_idTipus_Amonestacio
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE SEQUENCE seq_idTipus_Sancio
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE SEQUENCE seq_idAmonestacio
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE SEQUENCE seq_idSancio
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;



-- Creaci de disparadors
CREATE OR REPLACE 
TRIGGER inserir_Assignatura
  BEFORE INSERT ON Assignatura
  FOR EACH ROW
BEGIN
  SELECT seq_idAssignatura.NEXTVAL INTO :NEW.idAssignatura 
  FROM DUAL;
END inserir_Assignatura;

CREATE OR REPLACE 
TRIGGER inserir_Curs
  BEFORE INSERT ON Curs
  FOR EACH ROW
BEGIN
  SELECT seq_idCurs.NEXTVAL INTO :NEW.idCurs 
  FROM DUAL;
END inserir_Curs;

CREATE OR REPLACE 
TRIGGER actualitzar_ME_SancionsCursAny
  AFTER INSERT ON Curs
  FOR EACH ROW
DECLARE
  t_numSancions NUMBER(3):= 0;
BEGIN
  -- Sinsereix una fila a la taula Numero_Sancions_CursAny inicialitzant el valor de latribut numSancions.
  INSERT INTO Numero_Sancions_CursAny VALUES (:NEW.idCurs, :NEW.anyAcademic, t_numSancions);
END actualitzar_ME_SancionsCursAny;

CREATE OR REPLACE
TRIGGER INSERIR_CALENDARI_ESCOLAR 
  BEFORE INSERT ON CALENDARI_ESCOLAR 
  FOR EACH ROW 
DECLARE
  t_festiu CHAR(1);
BEGIN
  -- Comprova que la data introduda no caigui en dia festiu
  SELECT festiu INTO t_festiu FROM Calendari WHERE data = :NEW.data;
  IF (LOWER(t_festiu) = 's') THEN 
    raise_application_error (-20001, 'ERROR: La data no s correcta, el dia introdut s festiu.');
  END IF;
  
  -- Comprova que horaInici i horaFi estiguin dintre interval [00:00  23:59]
  IF ((SUBSTR(:NEW.horaInici,0,2) > '23') OR (SUBSTR(:NEW.horaInici,4,6) > '59')) THEN
    raise_application_error (-20002, 'ERROR: La hora inici no s vlida.');
  END IF;
   IF ((SUBSTR(:NEW.horaFi,0,2) > '23') OR (SUBSTR(:NEW.horaFi,4,6) > '59')) THEN
    raise_application_error (-20003, 'ERROR: La hora final no s vlida.');
  END IF;
  EXCEPTION
    WHEN no_data_found THEN
      raise_application_error (-20004, 'ERROR: La data introduda no est a la taula Calendari.');

END inserir_Calendari_Escolar;

CREATE OR REPLACE 
TRIGGER actualitz_AmonestacionsAlumnes
  AFTER INSERT ON Alumne
  FOR EACH ROW
DECLARE
  t_numAmonestacions NUMBER(3):= 0;
BEGIN
  -- Sinsereix una fila a la taula Numero_Amonestacions_Alumne inicialitzant el valor de latribut numAmonestacions.
  INSERT INTO Numero_Amonestacions_Alumne VALUES (:NEW.DNI, t_numAmonestacions);

  -- Sinsereix una fila a la taula Alumnes_Sense_Amonestacions.
  INSERT INTO Alumnes_Sense_Amonestacions VALUES (:NEW.DNI);

END actualitz_AmonestacionsAlumnes;

CREATE OR REPLACE
TRIGGER ACTUAL_ME_SANCIONSALUMCURS 
  AFTER INSERT ON MATRICULA 
  FOR EACH ROW 
DECLARE
  t_mitjanaSancions NUMBER(3):= 0;
  t_numSancions NUMBER(3):= 0;
BEGIN
  -- Sinsereix una fila a la taula Numero_Sancions_AlumneAny inicialitzant el valor de latribut numSancions.
  INSERT INTO Numero_Sancions_AlumneAny VALUES (:NEW.alumne, :NEW.anyAcademic, t_numSancions);

  -- Sinsereix una fila a la taula Mitjana_Sancions_Curs inicialitzant el valor de latribut mitjanaSancions i numSancions.
  INSERT INTO Mitjana_Sancions_Curs VALUES (:NEW.curs, :NEW.anyAcademic, t_mitjanaSancions, t_numSancions);

END actual_ME_SancionsAlumCurs;

CREATE OR REPLACE
TRIGGER ACTUALITZ_ME_AMONESTPROFESSOR AFTER INSERT ON IMPARTIR 
FOR EACH ROW 
DECLARE
  t_mitjanaAmonestacions NUMBER(3):= 0;
  t_numAmonestacions NUMBER(3):= 0;
BEGIN
  -- Sinsereix una fila a la taula Mitjana_Amonestacions_ProfessorAny inicialitzant el valor de latribut mitjanaAmonestacions i numAmonestacions.
  SELECT numAmonestacions INTO t_numAmonestacions
  FROM Mitjana_Amonestacions_ProfAny
  WHERE DNI = :NEW.professor AND anyAcademic = :NEW.anyAcademic;
  IF (t_numAmonestacions is null) THEN
    INSERT INTO Mitjana_Amonestacions_ProfAny VALUES (:NEW.professor, :NEW.anyAcademic, t_mitjanaAmonestacions, t_numAmonestacions);
  END IF;
END actualitz_ME_AmonestProfessor;

CREATE OR REPLACE 
TRIGGER inserir_Calendari_Tutoria
  BEFORE INSERT ON Calendari_Tutoria
  FOR EACH ROW
DECLARE
  t_festiu CHAR(1);
BEGIN
   -- Comprova que la data introduda no caigui en dia festiu
  SELECT festiu INTO t_festiu FROM Calendari WHERE data = :NEW.data;
  IF (LOWER(t_festiu) = 's') THEN 
    raise_application_error (-20001, 'ERROR: La data no s correcta, el dia introdut s festiu.');
  END IF;
  
  -- Comprova que horaInici i horaFi estiguin dintre interval [00:00  23:59]
  IF ((SUBSTR(:NEW.horaInici,0,2) > '23') OR (SUBSTR(:NEW.horaInici,4,6) > '59')) THEN
    raise_application_error (-20002, 'ERROR: La hora inici no s vlida.');
  END IF;
   IF ((SUBSTR(:NEW.horaFi,0,2) > '23') OR (SUBSTR(:NEW.horaFi,4,6) > '59')) THEN
    raise_application_error (-20003, 'ERROR: La hora final no s vlida.');
  END IF;
  
  EXCEPTION
    WHEN no_data_found THEN
      raise_application_error (-20004, 'ERROR: La data introduda no est a la taula Calendari.');

END inserir_Calendari_Tutoria;

CREATE OR REPLACE 
TRIGGER inserir_Tipus_Amonestacio
  BEFORE INSERT ON Tipus_Amonestacio
  FOR EACH ROW
BEGIN
  SELECT seq_idTipus_Amonestacio.NEXTVAL INTO :NEW.idTipus 
  FROM DUAL;
END inserir_Tipus_Amonestacio;

CREATE OR REPLACE 
TRIGGER inserir_Tipus_Sancio
  BEFORE INSERT ON Tipus_Sancio
  FOR EACH ROW
BEGIN
  SELECT seq_idTipus_Sancio.NEXTVAL INTO :NEW.idTipus 
  FROM DUAL;
END inserir_Tipus_Sancio;

CREATE OR REPLACE 
TRIGGER inserir_Amonestacio
  BEFORE INSERT ON Amonestacio
  FOR EACH ROW
BEGIN
  SELECT seq_idAmonestacio.NEXTVAL INTO :NEW.idAmonestacio
  FROM DUAL;
END inserir_Amonestacio;

CREATE OR REPLACE
TRIGGER ACTIVAR_SANCIO 
  AFTER INSERT ON AMONESTACIO 
  FOR EACH ROW 
DECLARE
  t_numAmonestacions NUMBER(3) := 0;
  t_idTipus NUMBER(5);
  t_valor NUMBER(2) := 0;
  PRAGMA AUTONOMOUS_TRANSACTION;
BEGIN
  SELECT COUNT(*) INTO t_numAmonestacions
  FROM Amonestacio
  WHERE amonestat = :NEW.amonestat AND tipusAmonestacio = :NEW.tipusAmonestacio;
  SELECT idTipus, valor INTO t_idTipus, t_valor
  FROM Tipus_Sancio
  WHERE tipusAmonestacio = :NEW.tipusAmonestacio;
  IF (t_numAmonestacions >= t_valor) THEN
    INSERT INTO Sancio (data, motiu, resolucio, sancionat, curs, anyAcademic, tipusSancio) VALUES (SYSDATE, 'Sanci automtica', 'Sanci automtica', :NEW.amonestat, :NEW.curs, :NEW.anyAcademic, t_idTipus);
  END IF;
  COMMIT;

END activar_Sancio;

CREATE OR REPLACE
TRIGGER ACTUALITZAR_ME_AMONESTACIONS AFTER INSERT ON AMONESTACIO 
FOR EACH ROW 
DECLARE
  t_numAmonestacions NUMBER(3) := 0;
  t_totalAmonestacionsAny NUMBER(3):= 0;
  t_mesAmonestador NUMBER(3):= 0;
  t_DNIMesAmonestador VARCHAR2(10);
  PRAGMA AUTONOMOUS_TRANSACTION;
BEGIN
  -- Sactualitza el valor de latribut numAmonestacions de la taula Numero_Amonestacions_Alumne
  UPDATE Numero_Amonestacions_Alumne 
  SET numAmonestacions = numAmonestacions + 1
  WHERE DNI = :NEW.amonestat;

  --Sactualitza el valor de latribut mitjanaAmonestacions i numAmonestacions de la taula Mitjana_Amonestacions_ProfessorAny. 
  SELECT numAmonestacions INTO t_numAmonestacions
  FROM Mitjana_Amonestacions_ProfAny
  WHERE DNI = :NEW.amonestador AND anyAcademic = :NEW.anyAcademic;
  SELECT SUM(numAmonestacions) INTO t_totalAmonestacionsAny
  FROM Mitjana_Amonestacions_ProfAny
  WHERE anyAcademic = :NEW.anyAcademic;
  t_numAmonestacions := t_numAmonestacions + 1;
  t_totalAmonestacionsAny := t_totalAmonestacionsAny + 1;
  UPDATE Mitjana_Amonestacions_ProfAny 
  SET numAmonestacions = t_numAmonestacions,
      mitjanaAmonestacions = t_numAmonestacions / t_totalAmonestacionsAny       
  WHERE DNI = :NEW.amonestador AND anyAcademic = :NEW.anyAcademic;
  
  -- Sactualitza el valor dels atributs numAmonestacions i DNI del professor ms amonestador de la taula Professor_Mes_Amonestador_Curs.
  SELECT DNI, numAmonestacions INTO t_DNIMesAmonestador, t_mesAmonestador
  FROM Professor_Mes_Amonestador_Curs
  WHERE curs = :NEW.curs AND anyAcademic = :NEW.anyAcademic;
  IF (t_DNIMesAmonestador = :NEW.amonestador) THEN
    UPDATE Professor_Mes_Amonestador_Curs
    SET numAmonestacions = t_mesAmonestador + 1
    WHERE DNI = :NEW.amonestador AND curs = :NEW.curs AND anyAcademic = :NEW.anyAcademic;
  else
    SELECT COUNT(*) INTO t_numAmonestacions
    FROM Amonestacio
    WHERE amonestador = :NEW.amonestador AND curs = :NEW.curs AND anyAcademic = :NEW.anyAcademic;
    IF (t_numAmonestacions > t_mesAmonestador) THEN
      DELETE Professor_Mes_Amonestador_Curs
      WHERE curs = :NEW.curs AND anyAcademic = :NEW.anyAcademic;
      INSERT INTO Professor_Mes_Amonestador_Curs VALUES (:NEW.amonestador,  :NEW.curs, :NEW.anyAcademic, t_numAmonestacions);
    ELSE
      IF (t_numAmonestacions = t_mesAmonestador) THEN
        INSERT INTO Professor_Mes_Amonestador_Curs VALUES (:NEW.amonestador,  :NEW.curs, :NEW.anyAcademic, t_numAmonestacions);
      END IF;
    END IF;
  END IF;

  -- Sesborra la fila de lalumne amonestat de la taula Alumnes_Sense_Amonestacions.
  DELETE Alumnes_Sense_Amonestacions 
  WHERE DNI = :NEW.amonestat;

END actualitzar_ME_Amonestacions;


CREATE OR REPLACE 
TRIGGER inserir_Sancio
  BEFORE INSERT ON Sancio
  FOR EACH ROW
BEGIN
  SELECT seq_idSancio.NEXTVAL INTO :NEW.idSancio 
  FROM DUAL;
END inserir_Sancio;

CREATE OR REPLACE
TRIGGER ACTUALITZAR_ME_SANCIONS AFTER INSERT ON SANCIO 
FOR EACH ROW 
DECLARE
  t_numSancions NUMBER(3):= 0;
  t_mitjana NUMBER(3);
  t_mesSancionat NUMBER(3):= 0;
  t_DNIMesSancionat VARCHAR2(10);
  t_totalSancionsCurs NUMBER(3):= 0;
BEGIN
  -- Sactualitza el valor de latribut numSancions de la taula Numero_Sancions_AlumneAny.
  UPDATE Numero_Sancions_AlumneAny 
  SET numSancions = numSancions + 1
  WHERE DNI = :NEW.sancionat;

  -- Sactualitza el valor dels atributs numSancions i DNI de lalumne ms sancionat de la taula Alumne_Mes_Sancionat_Any. 
  SELECT DNI, numSancions INTO t_DNIMesSancionat, t_mesSancionat
  FROM Alumne_Mes_Sancionat_Any
  WHERE anyAcademic = :NEW.anyAcademic;
  IF (t_DNIMesSancionat = :NEW.sancionat) THEN
    UPDATE Alumne_Mes_Sancionat_Any
    SET numSancions = t_mesSancionat + 1
    WHERE DNI = :NEW.sancionat AND anyAcademic = :NEW.anyAcademic;
  else
    SELECT COUNT(*) INTO t_numSancions
    FROM Sancio
    WHERE sancionat = :NEW.sancionat AND anyAcademic = :NEW.anyAcademic;
    IF (t_numSancions > t_mesSancionat) THEN
      DELETE Alumne_Mes_Sancionat_Any
      WHERE anyAcademic = :NEW.anyAcademic;
      INSERT INTO Alumne_Mes_Sancionat_Any VALUES (:NEW.sancionat,  :NEW.anyAcademic, t_numSancions);
    ELSE
      IF (t_numSancions = t_meSancionat) THEN
        INSERT INTO Alumne_Mes_Sancionat_Any VALUES (:NEW.sancionat,  :NEW.anyAcademic, t_numSancions);
      END IF;
    END IF;
  END IF;

  -- Sactualitza el valor de latribut numSancions de la taula Numero_Sancions_CursAny.
  UPDATE Numero_Sancions_CursAny 
  SET numSancions = t_numSancions + 1
  WHERE curs = :NEW.curs AND anyAcademic = :NEW.anyAcademic;

  -- Sactualitza el valor de latribut mitjanaSancions de la taula Mitjana_Sancions_Curs.
  SELECT numSancions INTO t_numSancions
  FROM Mitjana_Sancions_Curs
  WHERE curs = :NEW.curs AND anyAcademic = :NEW.anyAcademic;
  SELECT SUM(numSancions) INTO t_totalSancionsCurs
  FROM Mitjana_Sancions_Curs;
  t_numSancions := t_numSancions + 1;
  t_totalSancionsCurs := t_totalSancionsCurs + 1;
  UPDATE Mitjana_Sancions_Curs 
  SET numSancions = t_numSancions,
      mitjanaSancions = t_numSancions / t_totalSancionsCurs       
  WHERE curs = :NEW.curs AND anyAcademic = :NEW.anyAcademic;
  
END actualitzar_ME_Sancions;

